



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Ajax从服务器端获取数据</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Ajax从服务器端获取数据</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 03:57:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>写在前面的话</h1>
<blockquote><p>Ajax从服务器获取的数据都是字符串,但是通过不同的解析,可以解析为XML或JSON来进行应用.</p>
<p>一般来说.使用XML格式的数据比较通用,但是服务器和客户端解析起来都比较复杂一些;而使用JSON语句话,服务端需要多做一些工作,但到了客户端,通过使用eval()函数来进行解析,就会获得js对象,使用起来很方便.在使用过程中,究竟使用哪种方法,这个要根据项目的实际需要,建议:在能使用JSON的情况下,尽量使用JSON.</p>
<p>具体使用方法参见例子.</p></blockquote>
<h1>例子</h1>
<blockquote><p>1.XML数据user.xml</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8" ?&gt;<br />
&lt;users&gt;<br />
  &lt;user&gt;<br />
    &lt;username&gt;张三XML&lt;/username&gt;<br />
    &lt;age&gt;33&lt;/age&gt;<br />
  &lt;/user&gt;<br />
  &lt;user&gt;<br />
    &lt;username&gt;李四XML&lt;/username&gt;<br />
    &lt;age&gt;34&lt;/age&gt;<br />
  &lt;/user&gt;<br />
&lt;/users&gt;</pre>
</div></blockquote>
<blockquote><p>2.JSON数据user.js</p>
<div>
<pre class="prettyprint linenums">[<br />
    { username : "张三JSON", age : 33},<br />
    { username : "李四JSON", age : 34}<br />
]</pre>
</div></blockquote>
<blockquote><p>3.HTML页面代码</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;<br />
&lt;html xmlns="http://www.w3.org/1999/xhtml"&gt;<br />
&lt;head&gt;<br />
    &lt;title&gt;&lt;/title&gt;<br />
    &lt;style type="text/css"&gt;<br />
        table,td,th<br />
        {<br />
            border:solid 1px silver;<br />
            border-collapse:collapse;<br />
            text-align:center;<br />
        }    

        th,td<br />
        {<br />
            width:100px;<br />
            height:20px;<br />
        }<br />
    &lt;/style&gt;<br />
    &lt;script type="text/javascript"&gt;<br />
        function GetXML() {<br />
            var xmlHttp = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHttp");

            xmlHttp.open("get", "user.xml?random=" + Math.random(), true);

            xmlHttp.onreadystatechange = function () {<br />
                if (xmlHttp.readyState == 4 &amp;&amp; xmlHttp.status == 200) {<br />
                    //获取返回XML数据主体内容<br />
                    var result = xmlHttp.responseXML.documentElement;

                    //获得user节点元素<br />
                    var users = result.getElementsByTagName("user");

                    for (var i = 0; i &lt; users.length; i++) {<br />
                        //获取单个user信息<br />
                            var user = users[i];

                        //获取user具体信息<br />
                           var username = user.getElementsByTagName("username")[0].text;<br />
                        var age = user.getElementsByTagName("age")[0].text;

                        //添加行<br />
                        appendRow(username, age);<br />
                    }<br />
                }<br />
            }

            xmlHttp.send();<br />
        }

        //添加新行<br />
        function appendRow(username, age) {<br />
            var ui = document.getElementById("userinfo");

            //添加新行<br />
            var newRow = ui.insertRow(ui.rows.length);

            //添加新的单元格<br />
            newRow.insertCell(0).innerHTML = username;<br />
            newRow.insertCell(1).innerHTML = age;

        }

        function GetJSON() {<br />
            var xmlHttp = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHttp");

            xmlHttp.open("get", "user.js?random=" + Math.random(), true);

            xmlHttp.onreadystatechange = function () {<br />
                if (xmlHttp.readyState == 4 &amp;&amp; xmlHttp.status == 200) {<br />
                    var result = xmlHttp.responseText;

                    //使用eval函数使返回的字符串变成js对象<br />
                    var users = eval("(" + result + ")");

                    for (var i = 0; i &lt; users.length; i++) {<br />
                        //获取单个user信息<br />
                           var user = users[i];

                        //此处已经知道user数据的格式,故可以直接用user.username和user.age<br />
                        appendRow(user.username, user.age);<br />
                    }<br />
                }<br />
            }

            xmlHttp.send();<br />
        }

    &lt;/script&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;<br />
    &lt;input type="button" value="加载XML数据" onclick="GetXML();" /&gt;<br />
    &lt;input type="button" value="加载JSON数据" onclick="GetJSON();" /&gt;<br />
    &lt;br /&gt;<br />
    &lt;br /&gt;<br />
    &lt;table id="userinfo"&gt;<br />
        &lt;thead&gt;<br />
        &lt;tr&gt;<br />
            &lt;th&gt;<br />
                姓名<br />
            &lt;/th&gt;<br />
            &lt;th&gt;<br />
                年龄<br />
            &lt;/th&gt;<br />
        &lt;/tr&gt;&lt;/thead&gt;<br />
        &lt;tbody&gt;<br />
        &lt;/tbody&gt;<br />
    &lt;/table&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div></blockquote>
<h1>效果</h1>
<blockquote><p>运行页面,点击"加载XML数据"按钮,会从XML数据文件中读取数据并添加至表格中;点击"加载JSON数据"按钮,会从js文件中读取数据并添加至表格.</p>
<p><img referrerpolicy="no-referrer"src="https://images.cnblogs.com/cnblogs_com/oneword/201106/201106041913118675.png" /></p></blockquote>
<h1>注意</h1>
<blockquote><p>因为使用的Get请求,应注意缓存问题.</p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2w7loq.html">学习实战java虚拟机的计划图</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96le639.html">Spring-Context之八&colon;一些依赖注入的小技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/390k0mjq.html">python signal信号</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdyj37q.html">vbs下载文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd70d7q.html">OpenCV开发环境配置-Windows&sol;MinGW&sol;Clion&sol;CMake</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m7rwm8.html">Visual Studio Tools for Unity安装及使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkg4pz8.html">dubbo安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjze5j8.html">C&plus;&plus;开发中BYTE类型数组转为对应的字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eylp5j9.html">Spring Boot 2&period;0 教程 - 深入SpringAplication</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpyvxjq.html">&lbrack;Inside HotSpot&rsqb; Visual Studio2017编译调试openjdk12</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zodkmdq.html">IdentityServer4之Resource Owner Password Credentials&lpar;资源拥有者密码凭据许可&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgjy3r8.html">eclipse部分常用快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljzkgk9.html">js常用正则表达式判断</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzyx0e8.html">datetime 计算时间差</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjxkol9.html">React&period;js 新手教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4ko3e9.html">day3 三、基本数据类型和运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4nv6e9.html">Python开发之数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emjylm9.html">C&plus;&plus;多线程同步之Mutex&lpar;互斥量&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp5k1l9.html">ubuntu安装openssh-server 报依赖错误的解决过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p465w8.html">部署一个flask服务记录</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9p6n6zq.html">python基础&mdash;&mdash;定制类</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd1eezq.html">MongoDB csv文件导入导出</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zpor19.html">maven入门基础（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/495lg2e8.html">C&num;关键字params</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7vo41q.html">SVM NG课件1</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rpnm78.html">ASP&period;NET Web API 全局权限和全局异常处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/495l3oe8.html">Shell编程基础教程3--Shell输入与输出</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4545e9.html">makefile示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m6d509.html">js继承的概念</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zprrd9.html">Git学习笔记 git revert</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
